unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    NtsInfo, Info;

{$R *.dfm}

//--------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
end;

//--------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//--------------------------------------------------------------------
//  Just open the volume and dump its information.
procedure TForm1.Button1Click(Sender: TObject);

    procedure PutLine(const Msg: String);
    begin
        Memo1.Lines.Add(Msg);
    end;

var
    Drive: Char;
    VolumeInfo: NTFS_VOLUME_DATA_BUFFER;
    Err: String;
    Calc1, Calc2: Double;
begin
    Memo1.Clear();
    PutLine('Message from Original ...');
    PutLine('-----------------------------------');
    PutLine('NTFS Information Dump');
    PutLine('Copyright (C) 1997 Mark Russinovich');
    PutLine('http://www.ntinternals.com');
    PutLine('-----------------------------------');

    Drive := (TButton(Sender).Caption)[1];

    PutLine('');
    PutLine('NTFS VOLUME DATA OF [' + Drive + '] DRIVE');

    //  Get ntfs volume data
    if (GetNTFSInfo(Drive, VolumeInfo, Err)) then
    begin
        PutLine('');
        PutLine('Volume Size');
        PutLine('-----------');

        Calc1 := (VolumeInfo.NumberOfSectors.QuadPart * VolumeInfo.BytesPerSector)
               / (1024 * 1024);
        PutLine(Format('Volume size            : %.2f MB', [Calc1]));

        PutLine(Format('Total sectors          : %d', [VolumeInfo.NumberOfSectors.QuadPart]));

        PutLine(Format('Total clusters         : %d', [VolumeInfo.TotalClusters.QuadPart]));

        PutLine(Format('Free clusters          : %d', [VolumeInfo.FreeClusters.QuadPart]));

        Calc1 := (VolumeInfo.FreeClusters.QuadPart * VolumeInfo.BytesPerCluster)
               / (1024 * 1024);
        Calc2 := (VolumeInfo.FreeClusters.QuadPart * 100)
               / VolumeInfo.TotalClusters.QuadPart;
        PutLine(Format('Free space             : %.2f MB (%.2f%% of drive)', [Calc1, Calc2]));

        PutLine('');
        PutLine('Allocation Size');
        PutLine('----------------');

        PutLine(Format('Bytes per sector       : %d', [VolumeInfo.BytesPerSector]));

        PutLine(Format('Bytes per cluster      : %d', [VolumeInfo.BytesPerCluster]));

        PutLine(Format('Bytes per MFT record   : %d', [VolumeInfo.BytesPerMFTRecord]));

        PutLine(Format('Clusters per MFT record: %d', [VolumeInfo.ClustersPerMFTRecord]));


        PutLine('');
        PutLine('MFT Information');
        PutLine('---------------');

        Calc1 := VolumeInfo.MFTLength.QuadPart / (1024 * 1024);
        Calc2 := (VolumeInfo.MFTLength.QuadPart * 100 / VolumeInfo.BytesPerCluster)
               / VolumeInfo.TotalClusters.QuadPart;
        PutLine(Format('MFT size               : %.2f MB (%.2f%% of drive)', [Calc1, Calc2]));

        PutLine(Format('MFT start cluster      : %d', [VolumeInfo.MFTStart.QuadPart]));

        PutLine(Format('MFT zone clusters      : %d - %d', [
            VolumeInfo.MFTZoneStart.QuadPart,
            volumeInfo.MFTZoneEnd.QuadPart
            ]));

        Calc1 := (VolumeInfo.MFTZoneEnd.QuadPart - VolumeInfo.MFTZoneStart.QuadPart)
               * VolumeInfo.BytesPerCluster / (1024 * 1024);
        Calc2 := (VolumeInfo.MFTZoneEnd.QuadPart - VolumeInfo.MFTZoneStart.QuadPart)
               * 100 / VolumeInfo.TotalClusters.QuadPart;
        PutLine(Format('MFT zone size          : %.2f MB (%.2f%% of drive)', [Calc1, Calc2]));

        PutLine(Format('MFT mirror start       : %d', [VolumeInfo.MFTMirrorStart.QuadPart]));

        PutLine('');
        PutLine('Meta-Data files');
        PutLine('---------------');
        DumpMetaFiles(Drive, Memo1.Lines);
    end
    else
    begin
        PutLine('');
        PutLine(Err);
    end;
end;

end.
 
